#
# this is the VERSION 6 make file for ded.
# It is intended to reside on the 11/40, and is linked to 40.make.
# It contains facilities to make a wrap.out file to update ded
# on various other machines (make ccwrap, make 34wrap, etc.)
# and to receive updates from some of those machines (make 34unwrap, etc.)
#

# to make a new version of ded on a new machine under version 6,
#
#       make wrapall, which will produce ded1, ded2 and
#       ded3 (all wrap.out files)
#       transfer them to  the new machine and unwrap them
#       make sure the new machine has 'make' and 'v7cc' installed
#
#       edit the 'newded' and 'newdedlib' entries so that they have the
#               correct SITE and DRIVER entries
#
#       make newdedlib
#       make ded
#

FILES = alloc.c break.c change.c comm.c cursor.c dedprintf.c diag.c dlog.c draw.c editfile.c find.c global.c insert.c iocomm.c iofile.c join.c main.c mainloop.c map.c match.c range.c re.c rowcol.c scroll.c shuffile.c split.c str.c ter.c tmpfile.c tty.c unix.c word.c

LIBFILES = clrh0.c clrh1.c clrs0.c clrs1.c clrt0.c clrt1.c delc0.c delc1.c delc2.c dbug3.c dbug2.c dbug0.c dbug1.c insc0.c insc1.c insc2.c join0.c join1.c join2.c join3.c join4.c scr0.c scr1.c scr2.c scr3.c split0.c split1.c split2.c split3.c split4.c ttyback.c

HFILES = char.h ded.h file.h jmp.h lines.h match.h range.h signal.h ter.h tty.h

DEFFILES = chars.def def.template QMC.def UCL.def INMOS.def BIRKBECK.def LOGICA.def CC.def itt.def qmc1510.def txtter.def hazeltine.def newbury.def systime.def tec630.def tvi920.def

SOURCEFILES = $(FILES) $(LIBFILES) $(HFILES) $(DEFFILES) setjmp.s

DISTANTFILES = $(SOURCEFILES) 40.make ded.make ded.1.v6

dedlint: $(SOURCEFILES)
	lint -DV6 -DQMC -DQMCDRIVER $(FILES) $(LIBFILES) ^ tee dedlint

printall: .
	pr $(FILES) ^ facit
	pr $(LIBFILES) ^ facit
	pr $(HFILES) ^ facit
	pr $(DEFFILES) ded.1 makefile ded.make ^ facit
	touch dedprint

dedprint: $(SOURCEFILES) ded.1 makefile ded.make
	pr $? ^ facit
	touch dedprint

newded: . dedlib.a
	make -f ded.make QMCDED CC=v7cc VERSION=6 SITE=QMC DRIVER=QMC
	rm -f newded
	ln QMCDED newded
	-fs newded /bin/ded
	-size newded /bin/ded
	-file newded /bin/ded

dedlib.a: setjmp.o
	ar r dedlib.a setjmp.o

setjmp.o: jmp.h

ded: newded
	cp newded currded
	cp newded /bin/ded.new
	-strip /bin/ded.new
	rm /bin/ded
	mv /bin/ded.new /bin/ded
	chmod 1755 /bin/ded

foreignded: dedlib.a
	make -f ded.make $(SITE)DED CC=v7cc VERSION=6 SITE=$(SITE) DRIVER=$(DRIVER)

70wrap: 70ded
	-(chdir 70ded; wrap -f ../70wrap *; rm -f *)

70ded: $(DISTANTFILES)
	-if -r 70wrap sh -c "(mv 70wrap 70ded; chdir 70ded; unwrap 70wrap; rm 70wrap)"
	(wrap -f 70ded/70wrap $?; chdir 70ded; unwrap 70wrap; rm 70wrap)

70unwrap: 70ded
	unwrap from70wrap
	mv from70wrap 70ded
	rm 70ded/from70wrap

34wrap: 34ded
	-(chdir 34ded; wrap -f ../34wrap *; rm -f *)

34ded: $(DISTANTFILES)
	-if -r 34wrap sh -c "(mv 34wrap 34ded; chdir 34ded; unwrap 34wrap; rm 34wrap)"
	(wrap -f 34ded/34wrap $?; chdir 34ded; unwrap 34wrap; rm 34wrap)

34unwrap: 34ded
	unwrap from34wrap
	mv from34wrap 34ded
	rm 34ded/from34wrap

ccwrap: ccded
	-(chdir ccded; wrap -f ../ccwrap *; rm -f *)

ccded: $(DISTANTFILES)
	-if -r ccwrap sh -c "(mv ccwrap ccded; chdir ccded; unwrap ccwrap; rm ccwrap)"
	(wrap -f ccded/ccwrap $?; chdir ccded; unwrap ccwrap; rm ccwrap)

ccunwrap: ccded
	unwrap fromccwrap
	mv fromccwrap ccded
	rm ccded/fromccwrap

vaxwrap: vaxded
	-(chdir vaxded; wrap -f ../vaxwrap *; rm -f *)

vaxded: $(DISTANTFILES) 70.make ded.1.v7
	-if -r vaxwrap sh -c "(mv vaxwrap vaxded; chdir vaxded; unwrap vaxwrap; rm vaxwrap)"
	(wrap -f vaxded/vaxwrap $?; chdir vaxded; unwrap vaxwrap; rm vaxwrap)

vaxunwrap: vaxded
	unwrap fromvaxwrap
	mv fromvaxwrap vaxded
	rm vaxded/fromvaxwrap

wrapall:
	wrap -f ded1 $(FILES)
	wrap -f ded2 $(LIBFILES)
	wrap -f ded3 $(HFILES) $(DEFFILES) makefile ded.make ded.1.v6
