#
# this is a version 7 makefile for ded (see also ded.make).
# it is intended to reside on the 11/70, and so is linked to
# 70.make.  It contains facilities to send mods to the 11/40
# and to receive mods from it - see make 40wrap and make 40unwrap
#

#
# to make a new ded on your own machine,
#       edit this file so that the SITE and DRIVER entries under
#               newded and newdedlib are correct.
#       make newdedlib
#       make ded
#

CFILES = alloc.c break.c change.c comm.c cursor.c dedprintf.c diag.c dlog.c draw.c editfile.c find.c global.c insert.c iocomm.c iofile.c join.c main.c mainloop.c map.c match.c range.c re.c rowcol.c scroll.c shuffile.c split.c str.c ter.c tmpfile.c tty.c unix.c word.c

LIBFILES = clrh0.c clrh1.c clrs0.c clrs1.c clrt0.c clrt1.c delc0.c delc1.c delc2.c dbug3.c dbug2.c dbug0.c dbug1.c insc0.c insc1.c insc2.c join0.c join1.c join2.c join3.c join4.c scr0.c scr1.c scr2.c scr3.c split0.c split1.c split2.c split3.c split4.c ttyback.c

HFILES = char.h ded.h file.h jmp.h lines.h match.h range.h signal.h ter.h tty.h

DEFFILES = chars.def def.template QMC.def UCL.def INMOS.def BIRKBECK.def LOGICA.def CC.def itt.def qmc1510.def txtter.def hazeltine.def newbury.def systime.def tvi920.def tec630.def

SOURCEFILES = $(CFILES) $(LIBFILES) $(HFILES) $(DEFFILES)

dedlint: $(SOURCEFILES)
	cp $(SITE).def SITE.def
	lint -DV7 -D$(SITE) -D$(DRIVER)DRIVER -DDBUG $(CFILES) $(LIBFILES) ^ tee v7lint
	touch dedlint

dedprint: $(SOURCEFILES) 70.make ded.make v7lint
	pr $? ^ facit
	touch dedprint

newded: .
	make -f ded.make QMCDED VERSION=7 SITE=QMC DRIVER=QMC
	-rm -f newded
	ln QMCDED newded
	-if test -r /bin/ded; then size /bin/ded newded; file /bin/ded newded; fi

newdedlib:
	make -f ded.make newdedlib VERSION=7 SITE=QMC DRIVER=QMC

ded: newded
	cp newded currded
	cp newded /bin/ded.new
	strip /bin/ded.new
	-if test -r /bin/ded.old; then rm -f /bin/ded.old*; fs /bin/ded*; fi
	-if test -r /bin/ded.old; then mv /bin/ded.old /bin/ded.old.2; fi
	mv /bin/ded /bin/ded.old
	mv /bin/ded.new /bin/ded
	chmod 1755 /bin/ded
	rm -f /bin/ded.old*
	fs /bin/ded*

foreignded:
	make -f ded.make $(SITE)DED VERSION=7 SITE=$(SITE) DRIVER=$(DRIVER)
	size $(SITE)DED

40wrap: 40ded
	-(cd 40ded; wrap *; mv wrap.out ../40wrap; rm -f *)

40ded: $(SOURCEFILES) 70.make ded.make ded.1.v7 v7lint
	-if test -r 40wrap; then mv 40wrap 40ded/wrap.out; cd 40ded; unwrap; rm wrap.out; fi
	cp $? 40ded

40unwrap: 40ded
	-unwrap from40wrap
	mv from40wrap 40ded/wrap.out
	rm 40ded/wrap.out
