CFLAGS =  -DV$(VERSION) $(XFLAGS) -D$(SITE) -D$(DRIVER)DRIVER -DINTCOMP -DINTSPELL
# make a new ded library

# library files (in order)

LIBFILES = clrh1.o clrh0.o clrs1.o clrs0.o clrt1.o clrt0.o dbug3.o dbug2.o \
dbug1.o dbug0.o delc2.o delc1.o delc0.o insc2.o insc1.o insc0.o join3.o \
join2.o join1.o join0.o join4.o scr3.o scr2.o scr1.o scr0.o split3.o \
split2.o split1.o split0.o split4.o ttyback.o

# make a new version of ded

$(SITE)$(IC)DED: alloc.o break.o change.o comm_$(IC).o \
cursor.o dedprintf.o diag.o \
dlog.o draw.o editfile$(VERSION).o find$(VERSION).o global.o insert.o \
iocomm.o iofile$(VERSION).o join.o main.o mainloop_$(IC).o map.o match.o \
range.o re.o rowcol.o scroll.o shuffile.o split.o str.o ter.o \
tmpfile$(VERSION).o tty$(VERSION)$(SITE)$(DRIVER).o \
unix$(VERSION)$(IC).o word.o dedlib.a
	$(CC) -n $(LDFLAG) alloc.o \
break.o change.o comm_$(IC).o cursor.o dedprintf.o \
diag.o dlog.o draw.o editfile$(VERSION).o find$(VERSION).o global.o \
insert.o iocomm.o iofile$(VERSION).o join.o main.o mainloop_$(IC).o map.o \
match.o range.o re.o rowcol.o scroll.o shuffile.o split.o str.o ter.o \
tmpfile$(VERSION).o tty$(VERSION)$(SITE)$(DRIVER).o \
unix$(VERSION)$(IC).o word.o dedlib.a -o $(SITE)$(IC)DED

dbug0.o dbug1.o dbug2.o dbug3.o dedprintf.o main.o iocomm.o str.o: ded.h

alloc.o shuffile.o: ded.h lines.h

range.o: ded.h range.h

ttyback.o: ded.h tty.h

diag.o dlog.o rowcol.o word.o: ded.h char.h

re.o: ded.h match.h

unix6$(IC).o: unix.c ded.h signal.h
	$(CC) -c $(CFLAGS) unix.c
	mv unix.o unix6$(IC).o

unix7$(IC).o: unix.c ded.h signal.h /usr/include/signal.h
	$(CC) -c $(CFLAGS) unix.c
	mv unix.o unix7$(IC).o

insert.o clrh0.o clrh1.o clrs0.o clrs1.o clrt0.o clrt1.o delc0.o delc1.o \
delc2.o insc0.o insc1.o insc2.o: ded.h ter.h

break.o cursor.o draw.o join.o map.o scroll.o split.o ter.o join0.o join1.o \
join2.o join3.o join4.o scr0.o scr1.o scr2.o scr3.o split0.o split1.o \
split2.o split3.o split4.o: ded.h char.h ter.h

mainloop_$(IC).o: mainloop.c ded.h jmp.h ter.h
	$(CC) -c $(CFLAGS) mainloop.c
	mv mainloop.o mainloop_$(IC).o

editfile6.o: editfile.c ded.h char.h file.h lines.h
	$(CC) -c $(CFLAGS) editfile.c
	mv editfile.o editfile6.o

editfile7.o: editfile.c ded.h char.h file.h lines.h /usr/include/sys/types.h \
/usr/include/sys/stat.h
	$(CC) -c $(CFLAGS) editfile.c
	mv editfile.o editfile7.o

tmpfile6.o: tmpfile.c ded.h char.h file.h
	$(CC) -c $(CFLAGS) tmpfile.c
	mv tmpfile.o tmpfile6.o

tmpfile7.o: tmpfile.c ded.h char.h file.h /usr/include/sys/types.h \
/usr/include/sys/stat.h
	$(CC) -c $(CFLAGS) tmpfile.c
	mv tmpfile.o tmpfile7.o

match.o: ded.h char.h match.h

find6.o: find.c ded.h match.h signal.h
	$(CC) -c $(CFLAGS) find.c
	mv find.o find6.o

find7.o: find.c ded.h match.h signal.h /usr/include/signal.h
	$(CC) -c $(CFLAGS) find.c
	mv find.o find7.o

iofile6.o: iofile.c ded.h char.h file.h ter.h
	$(CC) -c $(CFLAGS) iofile.c
	mv iofile.o iofile6.o

iofile7.o: iofile.c ded.h char.h file.h ter.h /usr/include/sys/types.h \
/usr/include/sys/stat.h
	$(CC) -c $(CFLAGS) iofile.c
	mv iofile.o iofile7.o

change.o: ded.h char.h match.h signal.h ter.h

global.o: ded.h char.h jmp.h lines.h match.h signal.h ter.h tty.h

comm_$(IC).o: comm.c ded.h char.h jmp.h match.h ter.h range.h
	$(CC) -c $(CFLAGS) comm.c
	mv comm.o comm_$(IC).o

tty6$(SITE)$(DRIVER).o: tty.c ded.h char.h tty.h signal.h ter.h \
$(SITE).def
	cp $(SITE).def SITE.def
	$(CC) -c $(CFLAGS) tty.c
	mv tty.o tty6$(SITE)$(DRIVER).o

tty7$(SITE)$(DRIVER).o: tty.c ded.h char.h tty.h signal.h ter.h \
$(SITE).def /usr/include/signal.h /usr/include/sgtty.h
	cp $(SITE).def SITE.def
	$(CC) -c $(CFLAGS) tty.c
	mv tty.o tty7$(SITE)$(DRIVER).o

QMC.def: txtter.def qmc1510.def itt.def
	touch QMC.def
UCL.def: newbury.def
	touch UCL.def
INMOS.def: systime.def
	touch INMOS.def
BIRKBECK.def: tvi920.def
	touch BIRKBECK.def
LOGICA.def: tec630.def
	touch LOGICA.def
CC.def: qmc1510.def
UMIST.def: vt100.def cifer.def cf2634.def UMISThazel.def tek4023.def \
	   cfT2.def cf2841.def sjs.def UMISTchars.def dwa.def
	touch UMIST.def
UMISTc.def: cifer.def UMISTchars.def
	touch UMISTc.def
UMISTv.def: vt100.def UMISTchars.def
	touch UMISTv.def
UMISTh.def: UMISThazel.def UMISTchars.def
	touch UMISTh.def
UMISTt.def: tek4023.def UMISTchars.def
	touch UMISTt.def
COMPU.def: vt100.def vt52.def
	touch COMPU.def
BRISTOL.def: vt100.def dt22.def
	touch BRISTOL.def
dedlib.a: $(LIBFILES)
	-ar r dedlib.a $?
	ranlib dedlib.a
